#!/usr/bin/perl
#
# proxy.pl
#
# Aufschlsselung der Proxy-Nutzungen
#
# Joachim Deckers <deckersj@mariengymnasium-arnsberg.de>, 20.09.2000
# 
# 27.09.2000: Unterdrckung der Lehrerrechner usw. mglich
# 18.03.2000: Ausgabe der Userkennungen 

use strict;
use CGI qw/:standard/;

# Angabe des Netzwerkes, das fr die Ausgabe bercksichtigt werden soll:
my $netprefix = "192.168";

# Liste der NETBIOS-Hostnamen fr die Ausgabe
#  - fr jede Schule anzupassen
my %HOSTS = ('0.21' => 'platz1','0.22' => 'platz2','0.23' => 'platz3',
             '0.24' => 'platz4','0.25' => 'platz5','0.26' => 'platz6',
             '0.27' => 'platz7','0.28' => 'platz8','0.29' => 'platz9',
             '0.30' => 'platz10','0.31' => 'platz11','0.32' => 'platz12',
             '0.33' => 'chemie','0.20' => 'lehrer','1.41' => 'lehrzi',
             '1.11' => 'physik','0.1' =>'arktur','0.2' => 'print-n21',
	     '100.11' => 'dial-in'
);

# Liste der Rechner, fr die keine Ausgabe erfolgt (z. B. Lehrerzimmer, Sekretariat, ...)
#  - fr jede Schule anzupassen
my %HIDE = ( '1.41' => 1, '0.20' => 1, '1.11' => 1);#, '100.11' => 1 );

#
# Ab hier sollten keine Anpassungen mehr notwendig sein.

# Deklarationen
my $q = new CGI;

my $accesslog = "/var/log/proxy/access.log";
my $suffix="";
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime();
my $ausgabe=sprintf("%02d.%02d.%4d,%02d:%02d",$mday,$mon+1,$year>80?1900+$year:2000+$year,$hour,$min); # Uhrzeit fr Ausgabe in String
my ($ip,$cluser,$dummy,$zeit,$zone,$addr,$code,$tag,$monat,$jahr,$stunde,$minute,$sekunde,$rest,$i1,$i2,$i3,$i4,$startzeit,$endzeit,$sek,$versteckt);
my $nurhosts=0;
my %AUSGABE;
my $zaehl=0;



# Benutzerkennung merken
my $REMOTE = $q->remote_user();
my ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell,$expire) = getpwnam ($REMOTE);
my $HOST=$q->remote_host();
if ( "$REMOTE" eq "" ) { $REMOTE="anonymous" };

if ($q->param('anzeigen') eq '') { menue(); exit 0; }

# HTML Kopf ausgeben
print $q->header,
      $q->start_html(-title=>'Proxy-Zugriffe auf das World Wide Web',
        -author=>'Joachim Deckers <deckersj@mariengymnasium-arnsberg>',
        -BACKGROUND=>'whttxtr2.jpg');
print $q->h2("Auswertung der WWW-Zugriffe f&uuml;r <font color=darkred><b>".(split (/,/,$gcos))[0]." ($REMOTE)</b></font>");


# Parameter auswerten
#
# nur Hosts anzeigen?
if ($q->param('hosts')==1) { $nurhosts = 1; }
# welche Tage anzeigen?
$suffix=$q->param('suffix')-1;
if ($suffix != -1) { $suffix='.'.$suffix; } else { $suffix=''; }
# Start- und Endzeit ermitteln
$startzeit=$q->param('start');
$endzeit=$q->param('end');
if (($startzeit !~ /^\d+\:\d+\:\d+$/)&&($startzeit !~ /^\d+\:\d+$/)&&($startzeit !~ /^\d+$/)){
	print $q->p('Die Startzeit "'.$startzeit.'" wird ignoriert, da sie nicht dem Format hh:mm:ss bzw. hh:mm bzw. hh entspricht!');
	$startzeit='00:00:00';
}
if (($endzeit !~ /^\d+\:\d+\:\d+$/)&&($endzeit !~ /^\d+\:\d+$/)&&($endzeit !~ /^\d+$/)) {
	print $q->p('Die Endzeit "'.$endzeit.'" wird ignoriert, da sie nicht dem Format hh:mm:ss bzw. hh:mm bzw. hh entspricht!');
	$endzeit='23:59:59';
}
my ($s_h,$s_m,$s_s)=split(/:/,$startzeit,3);
my ($e_h,$e_m,$e_s)=split(/:/,$endzeit,3);
my $startsek = ($s_h*60+$s_m)*60+$s_s;
my $endsek = ($e_h*60+$e_m)*60+$e_s;

# zunchst nur das Datum auslesen 
# - fr Zugriffe zwischen 0 Uhr und vor logrotate (standard: 2 Uhr) ist das
#   Datum falsch, da nur der erste Eintrag bercksichtigt wird. Diese wrden also
#   noch dem Vortag zugerechnet.
#   Aber wer surft schon um die Zeit in der Schule...
open ALOG,"<$accesslog$suffix";
$_=<ALOG>;
close ALOG;
  ($ip,$dummy,$dummy,$zeit,$zone,$addr) = split (/ /,$_,6);
  $zeit =~ s/\[//g;
  ($tag,$monat,$jahr,$rest)=split(/\/|:/,$zeit,4);
  ($stunde,$minute,$sekunde)=split(/:/,$rest,3);
print "<b>Datum: $tag-$monat-$jahr, Zeit: $startzeit - $endzeit </b><br>\n";
print "<BR>";

#Logdatei einlesen
print '<table border="0"><tr><th>Platz</th><th>Benutzerkennung</th><th>Zeit</th><th>URL</th></tr>'."\n";
open ALOG,"<$accesslog$suffix";
while (<ALOG>) {
  chomp;
  ($ip,$cluser,$dummy,$zeit,$zone,$addr) = split (/ /,$_,6);
  $zeit =~ s/\[//g;
  ($tag,$monat,$jahr,$rest)=split(/\/|:/,$zeit,4);
  ($stunde,$minute,$sekunde)=split(/:/,$rest,3);
  $sek = ($stunde*60+$minute)*60+$sekunde;
  if ( ($sek>=$startsek) && ($sek<=$endsek)  ) { # Innerhalb des Zeitintervalls?
	  ($dummy,$addr,$code) = split (/\"/,$addr,3);
	  ($i1,$i2,$i3,$i4) = split (/\./,$ip,4);
	  if ($netprefix eq "$i1\.$i2") { # aus dem richtigen Netz heraus?
	          if ($HOSTS{"$i3\.$i4"} ne "") { $ip=$HOSTS{"$i3\.$i4"}; }
	      $addr =~ s/(.*)GET (.*) HT(.*)$/$2/;
	      $code =~ s/(\w*)(\d{3})(.*)$/$2/;
	      if ( !$HIDE{"$i3\.$i4"} ) { # Lehrerrechner usw. ggf. nicht anzeigen!
  	        if (!$nurhosts) # nur Startadressen auf Rechnern bercksichtigen
	          { if ( $addr =~ /\/$/ || $addr =~ /\.htm/i || $addr =~ /\.html/i) {
	            $AUSGABE{$zaehl++} = "$ip,$cluser,$stunde:$minute:$sekunde,$code,$addr";}
#	            print "<tr><td>$ip</td><td>$stunde:$minute:$sekunde</td><td><a href=\"$addr\" target=\"_blank\">".(($code>=400)?'<font color="'.(($code==403)?'red':'darkred').'">':'').$addr.(($code>=400)?'</font>':'')."</a></td></tr>\n"; }
	          }
	        else { # alle html-Dateien bercksichtigen
	         if ( $addr =~ /^.*\/\/[0-9|a-z|\.|\-]*\/$/i ) {
	            $AUSGABE{$zaehl++} = "$ip,$cluser,$stunde:$minute:$sekunde,$code,$addr"; }
#	            print "<tr><td>$ip</td><td>$stunde:$minute:$sekunde</td><td><a href=\"$addr\" target=\"_blank\">".(($code>=400)?'<font color="'.(($code==403)?'red':'darkred').'">':'').$addr.(($code>=400)?'</font>':'')."</a></td></tr>\n"; }
	        }   
	      } 
	      else { $HIDE{"$i3\.$i4"}++; } # aha, es 	wurden Eintrge unterdrckt.
	  }
  } 
}
close ALOG;

if ($q->param('sortierung') eq 'zeit') {
	foreach (sort { $a <=> $b } keys %AUSGABE) {
	  ($ip,$cluser,$zeit,$code,$addr) = split(/,/,$AUSGABE{$_},5);
	  $cluser = "<a href=\"user_aussperren.cgi?benutzer=$cluser\">$cluser</a>";
	  print "<tr><td>$ip</td><td>&nbsp;$cluser</td><td>$zeit</td><td>&nbsp;<a href=\"$addr\" target=\"_blank\">".(($code>=400)?'<font color="'.(($code==403)?'red':'darkred').'">':'').$addr.(($code>=400)?'</font>':'')."</a></td></tr>\n"; 
	}
} elsif ($q->param('sortierung') eq 'platz') {
	foreach (sort nach_platz keys %AUSGABE) {
	  ($ip,$cluser,$zeit,$code,$addr) = split(/,/,$AUSGABE{$_},5);
	  $cluser = "<a href=\"user_aussperren.cgi?benutzer=$cluser\">$cluser</a>";
	  print "<tr><td>$ip</td><td>&nbsp;$cluser</td><td>$zeit</td><td>&nbsp;<a href=\"$addr\" target=\"_blank\">".(($code>=400)?'<font color="'.(($code==403)?'red':'darkred').'">':'').$addr.(($code>=400)?'</font>':'')."</a></td></tr>\n"; 
	}
}
elsif ($q->param('sortierung') eq 'url') {
	foreach (sort nach_url keys %AUSGABE) {
	  ($ip,$cluser,$zeit,$code,$addr) = split(/,/,$AUSGABE{$_},5);
	  $cluser = "<a href=\"user_aussperren.cgi?benutzer=$cluser\">$cluser</a>";
	  print "<tr><td>$ip</td><td>&nbsp;$cluser</td><td>$zeit</td><td>&nbsp;<a href=\"$addr\" target=\"_blank\">".(($code>=400)?'<font color="'.(($code==403)?'red':'darkred').'">':'').$addr.(($code>=400)?'</font>':'')."</a></td></tr>\n"; 
	}
}
elsif ($q->param('sortierung') eq 'user') {
	foreach (sort nach_user keys %AUSGABE) {
	  ($ip,$cluser,$zeit,$code,$addr) = split(/,/,$AUSGABE{$_},5);
	  $cluser = "<a href=\"user_aussperren.cgi?benutzer=$cluser\">$cluser</a>";
	  print "<tr><td>$ip</td><td>&nbsp;$cluser</td><td>$zeit</td><td>&nbsp;<a href=\"$addr\" target=\"_blank\">".(($code>=400)?'<font color="'.(($code==403)?'red':'darkred').'">':'').$addr.(($code>=400)?'</font>':'')."</a></td></tr>\n"; 
	}
}
else {
	print "Interner Fehler<br>\nUng&uuml;ltiger Wert f&uuml;r den Parameter <i>sortierung</i>: ".$q->param('sortierung')."<br>\n";
}

# HTML Ende der Ausgabe
print "</table><HR>\n";
# Ggf. auf nicht bercksichtigte Eintrge hinweisen
$versteckt = 0;
foreach (keys %HIDE) { if ($HIDE{$_} > 1) {$versteckt++;} }
if ($versteckt) {
  print "<SMALL>Zugriffe folgender Rechner wurden nicht angezeigt:<BR><I>\n";
  foreach (keys %HIDE) { if ($HIDE{$_} > 1) {print "&nbsp;&nbsp;".(($HOSTS{"$_"} ne "") ? $HOSTS{$_}:"$netprefix\.$_");} }
}
print "</I></SMALL></BODY></HTML>\n";

# nach_platz()
# Vergleich zweier Eintrge 1. nach Platz und 2. nach Zeit
sub nach_platz() {
  my ($dum,$ip1,$ip2, $z1, $z2);
  ($ip1,$dum,$z1,$dum)=split(/,/,$AUSGABE{$a},4);
  ($ip2,$dum,$z2,$dum)=split(/,/,$AUSGABE{$b},4);
  if ($ip1 eq $ip2) { return $z1 cmp $z2; }
  else { return $ip1 cmp $ip2 };
}

# nach_user()
# Vergleich zweier Eintrge 1. nach User und 2. nach Zeit
sub nach_user() {
  my ($dum,$usr1,$usr2, $z1, $z2);
  ($dum,$usr1,$z1,$dum)=split(/,/,$AUSGABE{$a},4);
  ($dum,$usr2,$z2,$dum)=split(/,/,$AUSGABE{$b},4);
  if ($usr1 eq $usr2) { return $z1 cmp $z2; }
  else { return $usr1 cmp $usr2 };
}


# nach_url()
# Vergleich zweier Eintrge 1. nach URL und 2. nach Zeit
sub nach_url() {
  my ($dum,$u1,$u2, $z1, $z2);
  ($dum,$dum,$z1,$dum,$u1)=split(/,/,$AUSGABE{$a},5);
  ($dum,$dum,$z2,$dum,$u2)=split(/,/,$AUSGABE{$b},5);
  if ($u1 eq $u2) { return $z1 cmp $z2; }
  else { return $u1 cmp $u2 };
}


#
# menue()
#
# Ausgabe eine HTML-Forms fr die Anzeigeoptionen
#
sub menue() {
my (%labels,$i);
my %slabels = ('zeit'=>'Zugriffszeit','platz'=>'lokalem Rechner','user'=>'Benutzerkennung','url'=>'aufgerufener URL');

for ($i=0;$i<=10;++$i) {
        $labels{"$i"} = ($i>0) ? "vor $i Tagen":"heute";
}

print $q->header,
      $q->start_html(-title=>'Proxy-Zugriffe auf das World Wide Web',
        -author=>'Joachim Deckers <deckersj@mariengymnasium-arnsberg>',
        -BACKGROUND=>'whttxtr2.jpg'),
      $q->h2("Auswertung der WWW-Zugriffe"),
      $q->startform('POST',$q->url(),'application/x-www-form-urlencoded'),
	  $q->p('F&uuml;r welche Tage und Zeiten sollen Statistiken erstellt werden?'),
      '<table><tr><td width="50%">',
      $q->p('Tag: ',$q->popup_menu('suffix',[0,1,2,3,4,5,6,7,8,9,10],'0',\%labels)),
      $q->p('Startzeit: ',$q->textfield(-name=>'start',-default=>'00:00:00',-override=>1,-size=>8,-maxlength=>8)),
      $q->p('Endzeit: ',$q->textfield(-name=>'end',-default=>'23:59:59',-override=>1,-size=>8,-maxlength=>8)),
      $q->p($q->checkbox('hosts','checked','1','Nur Startseiten auf Hosts anzeigen')),
      '</td><td>',
      $q->p('Sortieren nach <BR>',$q->radio_group('sortierung',['zeit','platz','user','url'],'zeit','true',\%slabels)),
      # $q->p('Automatisch alle',$q->textfield('refresh','0',3,5),' Sekunden aktualisieren (0 f&uuml;r keine Aktualisierung).'),
      '</td></tr></table>',
      $q->hidden('anzeigen','ja'),
      $q->p($q->submit('submit','Abfragen'),'   ',$q->defaults('Zurcksetzen')),
      $q->endform(),
      "<HR><SMALL>R&uuml;ckfragen zum Skript an <A HREF=\"mailto:deckersj\@mariengymnasium-arnsberg.de\">Joachim Deckers</A>.</BODY></HTML>";
}

