#!/usr/bin/perl
#
# user_aussperren.cgi
#
# Benutzer in die Squid-Sperrliste eintragen und Squid neu starten
#
# Joachim Deckers <deckersj@mariengymnasium-arnsberg.de>, 14.01.2002
#
# 14.02.02: Protokollfunktion und Freigabe der Benutzer ergnzt (jd)

use strict;
use CGI qw/:standard/;

# Datei mit der Sperrliste (Userkennungen sind zeilenweise eingetragen)
my $dateiname = "/home/www/admin2/darfnicht";

# Fr den Versand von Mails muss hier ggf. die Domainangabe angepasst werden
# (zum Beispiel $domain = "mariengymnasium-arnsberg.de")
# Sollen Kopien der Mails an eine andere Adresse als postmaster gehen, muss auch
# der Wert von Verwaltung gendert werden
my $verwaltung="postmaster";
my $domain="arktur";

# Kommando fr den Neustart von squid
#  eigentlich sollte eine Rekonfigurierung ausreichen. Hat bei mir aber nicht gereicht...
my $neustart = "/usr/squid/bin/squid -k reconfigure"; # darf der User www das berhaupt?

# Ab hier sollten keine Anpassungen mehr notwendig sein.

my $q = new CGI;
my $mailcommand= "/usr/bin/mail";
my $protokolldatei = "/var/log/proxysperre.log";

# Benutzerkennung merken
my $REMOTE = $q->remote_user();
my ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell,$expire) = getpwnam ($REMOTE);
my $HOST=$q->remote_host();
if ( "$REMOTE" eq "" ) { $REMOTE="anonymous" }; # darf hier eigentlich nicht passieren...

# HTML Kopf ausgeben
print $q->header,
      $q->start_html(-title=>'Benutzer von der Nutzung des WWW-Proxy aussperren',
        -author=>'Joachim Deckers <deckersj@mariengymnasium-arnsberg>',
        -BACKGROUND=>'whttxtr2.jpg');
print $q->h2((($0 =~ /user_aussperren.cgi/)?"Sperren":"Freigeben")." eines Benutzers").
      $q->p("Sie sind angemeldet als <font color=darkred><b>".(split (/,/,$gcos))[0]." ($REMOTE)</b></font>");

if ($q->param('benutzer') eq '') { fehler(); }
elsif ($q->param('bestaetigt') eq 'ja') { sperren(); }
   else { bestaetigen(); }

print "<HR><SMALL>R&uuml;ckfragen zum Skript an <A HREF=\"mailto:deckersj\@mariengymnasium-arnsberg.de\">Joachim Deckers</A>.</BODY></HTML>";
exit 0;

sub bestaetigen() {

my $user=$q->param('benutzer');
my ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell,$expire) = getpwnam ($user);

print  $q->startform('POST',$q->url(),'application/x-www-form-urlencoded').
       $q->p("Wollen Sie den Benutzer <b><font color=\"red\">".(split (/,/,$gcos))[0]."</font></b> (<b><font color=\"red\">$name</font></b>) wirklich ".(($0 =~ /user_aussperren.cgi/)?"von der weiteren WWW-Nutzung aussperrren":"wieder f&uuml;r die WWW-Nutzung zulassen")."?").
       $q->hidden('benutzer',$user).
       $q->hidden('bestaetigt','ja').
       $q->p("Der Benutzer wird dann eine E-Mail zur Information erhalten. Sie k&ouml;nnen hier eine Erl&auml;uterung oder Begr&uuml;ndung eintragen, die an den Benutzer mit &uuml;bermittlet wird:").
       $q->p(
       $q->textarea('kommentar','',10,50)
       ).
       $q->center($q->submit('submit',"     Ja, Benutzer ".(($0 =~ /user_aussperren.cgi/)?"aussperren":"freigeben")."!     ")).
       $q->endform;            
}

sub sperren() {
my $user=$q->param('benutzer');
my $kommentar=$q->param('kommentar');
my ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell,$expire) = getpwnam ($user);
my %SPERRE;

print  $q->p("Der Benutzer <b><font color=\"red\">".(split (/,/,$gcos))[0]."</font></b> (<b><font color=\"red\">$name</font></b>) wird ".(($0 =~ /user_aussperren.cgi/)?"von der weiteren WWW-Nutzung ausgesperrt":"wieder zur WWW-Nutzung zugelassen")."...");
$name = (split (/,/,$gcos))[0];

open FILE,"<$dateiname";
foreach (<FILE>) {
	chomp;
	$SPERRE{"$_"} = 1;
	if (("$_" eq "$user")&&($0 =~ /user_aussperren.cgi/)) {
		print $q->p("<i><b>Der Benutzer ist bereits gesperrt!</b></i>");
		close FILE;
		return;
	}
}
close FILE;

$SPERRE{"$user"} = (($0 =~ /user_aussperren.cgi/)?1:0);

# Eintrag in Protokolldatei schreiben
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime();
my $ausgabe=sprintf("%4d-%02d-%02d %02d:%02d:%02d",2000+$year,$mon+1,$mday,$hour,$min,$sec); # Datum&Uhrzeit fr Ausgabe in String
my $c = $kommentar;
$c =~ s/\015//g;   # CR entfernen
$c =~ s/\n/ # /g; # LF ersetzen
open FILE,">>$protokolldatei";
print FILE "[$ausgabe] $user ($name) wurde durch ".$q->remote_user()." ".(($0 =~ /user_aussperren.cgi/)?"ausgesperrt":"freigegeben").". Kommentar: $c\n";
close FILE;
# Sperrdatei neu schreiben
open FILE,">$dateiname" || die "<b>Datei konnte nicht geschrieben werden!</b></body></html>";
foreach (sort { $a <=> $b } keys %SPERRE) {
	if ($SPERRE{"$_"} == 1) {print FILE "$_\n";}
}
close FILE;

my $retval = system "$neustart";

print $q->p("<b>Der Benutzer wurde ".(($0 =~ /user_aussperren.cgi/)?"gesperrt.":"freigegeben."))."</b>";

open MAIL,"|$mailcommand -s\"Surfkontrolle: ".(($0 =~ /user_aussperren.cgi/)?"Aussperrung":"Freigabe")." durch ".$q->remote_user()."\" $user,$verwaltung";
print MAIL "Hallo $name ($user),\n\nSie wurden durch den Benutzer mit der Kennung ".$q->remote_user()." ".(($0 =~ /user_aussperren.cgi/)?"von der weiteren WWW-Nutzung ausgesperrt":"wieder fr die WWW-Nutzung freigegeben").".\n\n";
print MAIL (($kommentar ne "")?"Zur Erluterung:\n$kommentar\n\n":"");
print MAIL "Rckfragen richten Sie bitte direkt an den Benutzer ".$q->remote_user().".\n\nMit freundlichen Gren\nIhre Surfkontrolle\n";
close MAIL;

&uebersicht();

}

       
sub uebersicht() {
my ($i, $actuser, @N, @M1, @MM);

print <<"EOF";
<H2>Folgende Benutzer d&uuml;rfen zur Zeit nicht mehr surfen:</H2>
EOF

$i = 0 ;
open INF, "<$dateiname";# | die "Fehler: Datei nicht lesbar!\n";
print"<TABLE width = \"100%\"><TR>\n";
foreach (<INF>) {
		chomp;
		$actuser = $_; 
		if (($actuser ne "nobody")&&($actuser ne "-")) {
                $i += 1;  
		print "<TD width=\"33%\"><b><a href=\"user_freigeben.cgi?benutzer=$actuser\">",$actuser,"</a></b>  " ;
		@N=`grep "^$actuser:" /etc/passwd` ;
                foreach (@N) { 
			@M1=split(":",$_);
                        if ( int($M1[2]) > 999) {
                            print "(";
                            @MM=split(",",$M1[4]);
			    print $MM[0];
                            print ")";
                            };
                        };
                print "</TD>\n";
                if ($i eq 3 ) {  
                   $i = 0 ; 
                   print "</TR><TR>\n";
                   };
		}
                };	
close INF;	
print "</TR></TABLE>\n";
}

sub fehler() {
  print $q->p("<b>Fehler: Es wurde kein Benutzer angegeben!</b>");	
}
